Gecode::SetValBranch Class Reference
Functionality by programming task » Programming models » Using integer set variables and constraints » Branching

Which values to select for branching first. More...

`#include <set.hh>`

## Public Types

enum | Select { SEL_MIN_INC , SEL_MIN_EXC , SEL_MED_INC , SEL_MED_EXC , SEL_MAX_INC , SEL_MAX_EXC , SEL_RND_INC , SEL_RND_EXC , SEL_VAL_COMMIT }
| Which value selection. More...
Public Types inherited from Gecode::ValBranch< SetVar >
typedef BranchTraits< SetVar >::Val | BranchVal
| The corresponding branching value function.
typedef BranchTraits< SetVar >::Commit | BranchCommit
| The corresponding branching commit function.

## Public Member Functions

| SetValBranch (Select s=SEL_MIN_INC)
| Initialize with selection strategy s.
| SetValBranch (Select s, Rnd r)
| Initialize with random number generator r.
| SetValBranch (SetBranchVal v, SetBranchCommit c)
| Initialize with value function f and commit function c.
Select | select (void) const
| Return selection strategy.
Public Member Functions inherited from Gecode::ValBranch< SetVar >
| ValBranch (void)
| Initialize.
Rnd | rnd (void) const
| Return random number generator.
BranchVal | val (void) const
| Return value function.
BranchCommit | commit (void) const
| Return commit function.

## Protected Attributes

Select | s
| Which value to select.
Protected Attributes inherited from Gecode::ValBranch< SetVar >
Rnd | r
| Random number generator.
BranchVal | vf
| Value function.
BranchCommit | cf
| Commit function.

## Detailed Description

Which values to select for branching first.

Definition at line 1447 of file set.hh.

## Member Enumeration Documentation

## Select

enum Gecode::SetValBranch::Select

Which value selection.

Enumerator
SEL_MIN_INC | Include smallest element.
SEL_MIN_EXC | Exclude smallest element.
SEL_MED_INC | Include median element (rounding downwards).
SEL_MED_EXC | Exclude median element (rounding downwards).
SEL_MAX_INC | Include largest element.
SEL_MAX_EXC | Exclude largest element.
SEL_RND_INC | Include random element.
SEL_RND_EXC | Exclude random element.
SEL_VAL_COMMIT | Select value according to user-defined functions.

Definition at line 1450 of file set.hh.

## Constructor & Destructor Documentation

## SetValBranch() [1/3]

Gecode::SetValBranch::SetValBranch | ( | Select | s = SEL_MIN_INC | ) |

inline

Initialize with selection strategy s.

Definition at line 37 of file val.hpp.

## SetValBranch() [2/3]

Gecode::SetValBranch::SetValBranch | ( | Select | s,
|  | Rnd | r )

inline

Initialize with random number generator r.

Definition at line 41 of file val.hpp.

## SetValBranch() [3/3]

Gecode::SetValBranch::SetValBranch | ( | SetBranchVal | v,
|  | SetBranchCommit | c )

inline

Initialize with value function f and commit function c.

Definition at line 45 of file val.hpp.

## Member Function Documentation

## select()

SetValBranch::Select Gecode::SetValBranch::select | ( | void |  | ) | const

inline

Return selection strategy.

Definition at line 49 of file val.hpp.

## Member Data Documentation

## s

Select Gecode::SetValBranch::s

protected

Which value to select.

Definition at line 1463 of file set.hh.

The documentation for this class was generated from the following files:

- gecode/set.hh
- gecode/set/branch/val.hpp